///home/berryj/link/bin/genMethods "-g" "-t" "Edge*" "-h" "MSet" "-r" "Collection<Edge*>" "-I" "LINK/basic/MSet.h" "-I" "LINK/graph/Edge.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/MSet.h>

#include <LINK/graph/Edge.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Edge* _Edge_;
typedef MSet<Edge* > _MSet_Edge__;
static MSet<Edge* > s__MSet_Edge__;

#define _MSet_Edge__DATA(x) ((MSet<Edge* >*) (EXTDATA(x)))
#define _MSet_Edge__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<Edge* > >::type))
#define _MSet_Edge__ISNT_DATA(x) (!_MSet_Edge__IS_DATA(x))

#define _MSet_Edge__CXX_DATA(x) (*(MSet<Edge* >*) (EXTDATA(VAL(x))))
#define _MSet_Edge__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<MSet<Edge* > >::type))
#define _MSet_Edge__CXX_ISNT_DATA(x) (!_MSet_Edge__CXX_IS_DATA(x))


PRIMITIVE STk_init__MSet_Edge__()
{
	Wrapper<_MSet_Edge__>::type = STk_new_CXXwrapper_id(
			Wrapper<_MSet_Edge__>::name, 
			Wrapper<Collection<Edge*> >::name,
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Edge_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Edge_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Edge_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_MSet_Edge__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_MSet_Edge__Methods(void);

PRIMITIVE STk_init_methods__MSet_Edge__()
{
	genExtra_MSet_Edge__Methods();
	return UNDEFINED;
}
